local colors = {
	"white", "\x80", SKINCOLOR_WHITE,
	--"magenta", "\x81", SKINCOLOR_WHITE,
	"yellow", "\x82", SKINCOLOR_YELLOW,
	"green", "\x83", SKINCOLOR_GREEN,
	"blue", "\x84", SKINCOLOR_BLUE,
	"red", "\x85", SKINCOLOR_RED,
	"orange", "\x87", SKINCOLOR_ORANGE,
	--"sky", "\x88", SKINCOLOR_WHITE,
	"black", "\x8f", SKINCOLOR_BLACK,
}
WARE_AddMinigame("text", {
	--prompt = "Type the text in chat:",
	
	music = "WAMTXT",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		
		local chooseTxt = P_RandomRange(1,#colors/3)
		local chooseCol = P_RandomRange(1,#colors/3)
		mem.text = colors[ chooseTxt*3-2 ]
		mem.color = colors[ chooseCol*3 ]
		mem.colortext = colors[ chooseCol*3-2 ]
		
		mem.wantText = P_RandomChance(FRACUNIT/2)
	end,
	fThink = function()
		local mem = WARE.mem
	end,
	fHud = function(v,p,c)
		--function(v, x, y, str, font, flags, extra
		local mem = WARE.mem
		local str = mem.wantText and "word" or "color"
		drawStringMkII(v,160*FRACUNIT,42*FRACUNIT,"Type the "..str..":",FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED})
		drawStringMkII(v,160*FRACUNIT,54*FRACUNIT,mem.text,FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=mem.color,style=FS_FIXED,scale=FRACUNIT*2})
	end,
	
	hPlayerMsg = function(p, t, _, msg)
		local mem = WARE.mem
		--print("Trying to intercept")
		if WARE_PlayerCompeting(p) and t == 0 then
			local msg = msg:lower()
			if mem.wantText then
				if msg == mem.text then WARE_PlayerSetStatus(p, true, true) end
			else
				if msg == mem.colortext then WARE_PlayerSetStatus(p, true, true) end
			end
		end
	end,
	
	--f
})
local function operstr()
	local op = WARE.mem.oper
	return op == 1 and "+" or op == 2 and "-" or op == 3 and "*" or "?"
end
WARE_AddMinigame("math", {
	--prompt = "quik mafs",
	
	music = "WAMMAF",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		
		// We don't store the result here lol
		mem.oper = P_RandomRange(1,3)
		if mem.oper < 3 then
			// Copying what tf2ware did
			mem.n1 = P_RandomRange(3,12*(WARE.speed+1))
			mem.n2 = P_RandomRange(3,12*(WARE.speed+1))
		else // mult
			mem.n1 = P_RandomRange(2,10)
			mem.n2 = P_RandomRange(2,10)
		end
		
		mem.first = false
		
	end,
	fThink = function()
		local mem = WARE.mem
	end,
	fHud = function(v,p,c)
		--function(v, x, y, str, font, flags, extra
		local mem = WARE.mem
		local str = mem.wantText and "word" or "color"
		drawStringMkII(v,160*FRACUNIT,42*FRACUNIT,"Type the answer in chat:",FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED})
		local restxt = mem.n1.." "..operstr().." "..mem.n2
		drawStringMkII(v,160*FRACUNIT,54*FRACUNIT,restxt,FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_VIOLET,style=FS_FIXED,scale=FRACUNIT*2})
	end,
	hPlayerMsg = function(p, t, _, msg)
		local mem = WARE.mem
		local result
		if mem.oper == 1 then result = mem.n1 + mem.n2
		elseif mem.oper == 2 then result = mem.n1 - mem.n2
		elseif mem.oper == 3 then result = mem.n1 * mem.n2
		else error("what the fuck") end
		if result == nil then error("wtf") end
		local correctAnswer = tonumber(msg:lower()) == result
		if WARE_PlayerCompeting(p) and t == 0 then
			if correctAnswer then
				WARE_PlayerSetStatus(p, true, true)
				if not mem.first then
					mem.first = true
					chatprint(WARETAG.."\139 "..p.name.." guessed the answer first!")
				end
				return true
			end
		end
		if correctAnswer then return true end // Don't show the result, stupid
	end,
	fEnd = function()
		local mem,result = WARE.mem,0
		if mem.oper == 1 then result = mem.n1 + mem.n2
		elseif mem.oper == 2 then result = mem.n1 - mem.n2
		elseif mem.oper == 3 then result = mem.n1 * mem.n2
		else error("what the fuck") end
		chatprint(WARETAG.."\139 The answer was \128"..result.."\139!")
	end,
	
	--f
})


local oldorders = {
	{"Jump!", function(p,simon) return (p.pflags & PF_STARTJUMP)>0 end},
	{"Spin!", function(p,simon) return (p.pflags & PF_SPINNING)>0 end},
	{"Charge a spindash!", function(p,simon) return (p.pflags & PF_STARTDASH)>0 end},
	{"Thok!", function(p,simon) return (p.pflags & PF_THOKKED)>0 end},
	//{"Use your shield ability!", function(p,simon) return (p.pflags & PF_SHIELDABILITY)>0 end},
	//{"Move!", function(p,simon) return (p.pflags & PF_SPINNING)>0 end},
}

local ab1 = {
	     sonic = "Thok!",
	     tails = "Fly!",
	  knuckles = "Glide!",
	metalsonic = "Float!",
	       amy = "Twinspin!",
	      fang = "Bounce!",
}
local hasthokked = function(p) return (p.pflags & PF_THOKKED)>0 end
local ab1a = { // (p.pflags & PF_THOKKED)>0
	     sonic = hasthokked,
	     tails = hasthokked,
	  knuckles = hasthokked,
	metalsonic = hasthokked,
	       amy = function(p) return p.panim == PA_ABILITY end,
	      fang = function(p) return p.mo.state == S_PLAY_BOUNCE_LANDING end,
}
local ab2 = {
	     sonic = "Spin!",
	     tails = "Spin!",
	  knuckles = "Spin!",
	metalsonic = "Spin!", // bruh
	       amy = "Hammer!",
	      fang = "Shoot a cork!",
}
local hasspun = function(p) return (p.pflags & PF_SPINNING)>0 end
local ab2a = {
	     sonic = hasspun,
	     tails = hasspun,
	  knuckles = hasspun,
	metalsonic = hasspun, // bruh
	       amy = function(p) return p.panim == PA_ABILITY2 end,
	      fang = function(p) return p.panim == PA_ABILITY2 end,
}
local allskins = {"sonic","tails","knuckles","metalsonic","amy","fang"}
local orderlook = {
	{
		skins = allskins,
		prompt = function()
			return "Jump!"
		end,
		action = function(p)
			return (p.pflags & PF_STARTJUMP)>0
		end,
	},	{
		skins = allskins,
		prompt = function()
			return ab1[WARE.mem.skin]
		end,
		action = function(p)
			return ab1a[p.mo.skin](p)
		end,
	},	{
		skins = allskins,
		prompt = function()
			return ab2[WARE.mem.skin]
		end,
		action = function(p)
			return ab2a[p.mo.skin](p)
		end,
	}
}
WARE_AddMinigame("simon", {
	music = "WAMSMN",
	
	nodeath = true,
	
	timelimit = 3*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		mem.isSimon = P_RandomChance(FRACUNIT/2)
		mem.order = P_RandomRange(1,#orderlook)
		local o = orderlook[mem.order]
		mem.skin = o.skins[P_RandomRange(1,#o.skins)]
		--mem.skin = randomChoose{"amy","fang"} -- for testin
		mem.prompt = o.prompt()
		WARE_ForEachPlayer(function(p)
			WARE_ForcePlayerSkin(p, mem.skin)
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		local makeit = WARE.scaledtime > TICRATE*2/3
		WARE_ForEachPlayer(function(p)
			local o = orderlook[mem.order]
			local r = o.action(p)
			if mem.isSimon then
				if r then WARE_PlayerSetStatus(p, true, makeit)
				else WARE_PlayerSetStatus(p, false) end
			else
				if r then WARE_PlayerSetStatus(p, false, makeit)
				else WARE_PlayerSetStatus(p, true) end
			end
		end)
	end,
	fHud = function(v,p,c)
		local mem = WARE.mem
		local who = mem.isSimon and "Simon" or "Someone"
		//local order = orders[mem.order]
		local orderp = mem.prompt
		drawStringMkII(v,160*FRACUNIT,42*FRACUNIT,who.." says:",FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED})
		drawStringMkII(v,160*FRACUNIT,54*FRACUNIT,orderp,FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_COBALT,style=FS_FIXED,scale=FRACUNIT*2})
		
		if not mem.isSimon and p.waremem.wonlock and not p.waremem.won then
			drawStringMkII(v,160*FRACUNIT,72*FRACUNIT,"That wasn't Simon!",FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_YELLOW,style=FS_FIXED,scale=FRACUNIT})
		end
	end,
	
	--f
})


WARE_AddMinigame("dontdrown", {
	prompt = "Grab a bubble!",
	
	music = "WAMUNW",
	skin = "sonic",
	
	timelimit = 4*TICRATE,
	
	spawnpoint = {x=3200,y=0,z=0},
	positioning = {"radial",16*FRACUNIT},
	
	fStart = function()
		local mem = WARE.mem
		for p in players.iterate do
			p.powers[pw_underwater] = underwatertics-TICRATE
		end
		local sx = 3200*FRACUNIT
		local sy = 0
		for i = 1,WARE.playercount do
			--local xr = P_RandomRange(-1280,1280)*FRACUNIT
			local xr = P_RandomRange(-512,512)*FRACUNIT
			local yr = P_RandomRange(-512,512)*FRACUNIT
			local b = P_SpawnMobj(sx+xr,sy+yr,0,MT_EXTRALARGEBUBBLE)
		end
	end,
	fThink = function()
		local mem = WARE.mem
		for p in players.iterate do
			if p.powers[pw_underwater] > underwatertics-TICRATE then
				WARE_PlayerSetStatus(p, true, true)
			end
			p.powers[pw_underwater] = underwatertics-TICRATE
		end
	end,
	hMobjThinker = function(m)
		if m.type == MT_EXTRALARGEBUBBLE then
			m.frame = $|FF_FULLBRIGHT
		end
	end,
})

WARE_AddMinigame("touchsky", {
	prompt = "Touch the sky!",
	
	music = "WAMSKY",
	skin = "tails",
	
	timelimit = 9*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			p.mo.momz = -80*FRACUNIT
		end)
	end,
	fThink = function()
		for p in players.iterate do if WARE_PlayerInPlay(p) then
			if p.mo.z >= (1024-48)*FRACUNIT then
				if WARE_PlayerSetStatus(p, true, true) then
					p.mo.momz = -20*FRACUNIT
				end
			end
		end end
	end,
})

WARE_AddMinigame("land", {
	prompt = "Land on the platform!",
	
	music = "WAMLND",
	skin = "tails",
	
	timelimit = 4*TICRATE,
	
	spawnpoint = {x=0,y=2560,z=1536},
	positioning = {"radial",480*FRACUNIT},
	
	fStart = function()
		local mem = WARE.mem
		for p in players.iterate do if WARE_PlayerInPlay(p) then
			p.pflags = PF_THOKKED
			p.mo.state = S_PLAY_FLY_TIRED
			p.powers[pw_tailsfly] = 1
			local force = FixedMul(-FRACUNIT*3, WARE.spdcoef)
			p.mo.momz = force
			P_TeleportMove(p.mo,p.mo.x,p.mo.y,p.mo.z-(24*FRACUNIT*WARE.speed))
		end end
	end,
	fThink = function()
		for p in players.iterate do if WARE_PlayerInPlay(p) then
			if P_IsObjectOnGround(p.mo) then WARE_PlayerSetStatus(p, true, true) end
			if p.mo.z <= 448*FRACUNIT then
				WARE_PlayerSetStatus(p, false, true)
			end
		end end
	end,
})

local platforms = {7,6,10,9,5,4,3,8,1} // 16, 32, 48 hardcoded af
WARE_AddMinigame("lava", {
	prompt = "Get on a platform!",
	
	music = "WAMHOT",
	skin = "sonic",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local lava = sectors[19]
		lava.ceilingheight = -TICRATE*FRACUNIT
		
		local ps = deepcopy(platforms)
		local num = P_RandomRange(6,8)
		for i = 1,num do
			local ix = table.remove(ps, P_RandomRange(1,#ps))
			sectors[ix].floorheight = 0
		end
		for i = 1,#ps do
			sectors[ps[i]].floorheight = 48*FRACUNIT
		end
	end,
	fThink = function()
		local lava = sectors[19]
		if WARE.scaledtime > TICRATE+TICRATE/2 then
			local rs = FixedMul(2*FRACUNIT,WARE.spdcoef)
			lava.ceilingheight = min($+rs, 15*FRACUNIT)
		end
		for p in players.iterate do if WARE_PlayerInPlay(p) then
			WARE_PlayerSetStatus(p, true, false)
		end end
	end,
	hMobjDamage = function(m,inf,src,dmg,dmgtype)
		local p = m.player
		if p and p.valid and WARE_PlayerInPlay(p) then
			WARE_PlayerSetStatus(p, false, true)
		end
		return
	end,
	fEnd = function()
		WARE_FixOrigin()
	end
})

WARE_AddMinigame("killbot", {
	prompt = "Destroy a badnik!",
	
	music = "WAMBOT", // Used to share the same music as minigame target
	--skin = "sonic",
	
	timelimit = 4*TICRATE,
	nodeath = true,
	
	fStart = function()
		local mem = WARE.mem
		for i = 1,WARE.playercount+2 do
			--local xr = P_RandomRange(-1280,1280)*FRACUNIT
			local xr = P_RandomRange(-1024,1024)*FRACUNIT
			local yr = P_RandomRange(-1024,1024)*FRACUNIT
			local b = P_SpawnMobj(xr,yr,128*FRACUNIT,MT_BLUECRAWLA)
			b.angle = P_RandomRange(0,359)*ANG1
		end
	end,
	hMobjDamage = function(m,i,s)
		if (m.flags & MF_ENEMY) and s and s.valid and s.type == MT_PLAYER then
			WARE_PlayerWin(s.player, true)
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & MF_ENEMY) then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("hitenemy", {
	prompt = "Kill a player!",
	
	condition = function() return WARE.playercount > 1 end,
	
	music = "WAMHIT",
	skin = "fang",
	forcedeath = true,
	weaponrings = true,
	
	timelimit = 4*TICRATE,
	
	fThink = function()
		WARE_ForEachPlayer(function(p)
			p.rings = 1
		end)
	end,
	hMobjDamage = function(m,i,s)
		if s and s.type == MT_PLAYER and m.type == MT_PLAYER then
			WARE_PlayerWin(s.player, true)
		end
	end,
	fEnd = function()
		WARE_ForEachPlayer(function(p)
			p.rings = 0 --p.mo.flags = $ & ~(MF_SHOOTABLE)
		end)
	end
})

WARE_AddMinigame("climb", {
	prompt = "Climb!",
	
	music = "WAMCLB",
	skin = "knuckles",
	
	spawnpoint = {x=3072,y=2432,z=0},
	--positioning = {"radial",480*FRACUNIT},
	
	timelimit = 10*TICRATE,
	
	fStart = function() // Refactored @ beta3
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			p.mo.angle = ANGLE_90
		end)
		local center = {x=3072*FRACUNIT,y=(2624-24)*FRACUNIT}
		local ravioli = function(ae) return center.x + ((ae*64)*FRACUNIT) end
		local distmax = max(0, 3 - (WARE.speed/2)) // straight line at worst
		//local distmax = 0
		
		local past = {}
		for z = 128,1024,256 do // For each row
			--print("iter "..z)
			--print("past  "..table.concat(past, ","))
			local spike = makeRange(-4,4)
			local function fuck(p,n) p[#p+1] = n; end
			local punch = P_RandomRange(1,2)
			//local punch = 1
			
			if #past > 0 then
				// past: table signaling where are previous gaps
				// ex: past = {5}
				local aux = {}
				for six = 1,9 do // spike index
					local kill = true
					for pix = 1,#past do
						// if abs(5 - 9) <= 4
						// i.e. within range of a previous gap
						if abs(past[pix] - six) <= distmax then kill = false end
					end
					if not kill then
						// *possible* spaces for gaps
						aux[#aux+1] = six
					end
				end
				
				past = {}
				// and now make as many gaps as needed
				for i = 1,punch do
					local thisAuxIx = table.remove(aux, P_RandomRange(1,#aux))
					local thisSpikeIx = table.remove(spike, thisAuxIx)
					past[#past+1] = thisAuxIx
				end
			else
				// No past?
				// Remove centermost spike
				if z ~= 128 then
					error("There MUST be a past right now!")
				end
				table.remove(spike, 5)
				past = {5}
			end
			
			--print("spike "..table.concat(spike, ","))
			
			spike[#spike+1] = 5
			spike[#spike+1] = -5
			
			// Spawn spikes now
			// spike is a table with integer positions of where do they go
			local zr = z*FRACUNIT
			
			for pos = 1,#spike do
				local n = spike[pos]
				
				local s = P_SpawnMobj(ravioli(n), center.y, zr, MT_SPIKEBALL)
				s.scale = FRACUNIT*3/2
				if abs(n) == 5 then
					s.color = SKINCOLOR_RED
					s.colorized = true
				end
			end
		end
	end,
	fThink = function()
		for p in players.iterate do if WARE_PlayerInPlay(p) then
			if p.mo.z >= (1024)*FRACUNIT then
				WARE_PlayerSetStatus(p, true, true)
			end
			if p.powers[pw_flashing] then WARE_PlayerSetStatus(p, false, true) end
		end end
	end,
	fEnd = function(v,p,c)
		local mem = WARE.mem
		for m in mobjs.iterate() do
			if (m.flags & MF_PAIN) then P_RemoveMobj(m) end
		end
	end,
})

// MAPPOS_FiringRange
WARE_AddMinigame("target", {
	prompt = {"Shoot the crawla!","You have 1 rail!"},
	
	music = "WAMTGT",
	skin = "fang",
	
	spawnpoint = MAPPOS_FiringRange,
	positioning = {"scatter",{x=-3840,y=256,z=0},{x=-2304,y=-128,z=0}},
	nodeath = true,
	weaponrings = true,
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		WARE_ForEachPlayer(function(p)
			p.powers[pw_railring] = 1
			p.ringweapons = RW_RAIL
			p.currentweapon = WEP_RAIL
			p.mo.angle = ANGLE_45+P_RandomRange(0,90)*ANG1
		end)
		// -3072 2752
		// 1536
		local cc = P_SpawnMobj(
			(-3072 + P_RandomRange(-750,750))*FRACUNIT,
			2752*FRACUNIT,
			0, MT_REDCRAWLA
		)
		cc.angle = ANGLE_270
	end,
	hMobjDamage = function(m,i,s)
		// 
		--if m.type == MT_PLAYER then return true end
		if s and s.type == MT_PLAYER and i and i.type == MT_REDRING then
			if m.type == MT_REDCRAWLA then
				WARE_PlayerWin(s.player, true)
				P_KillMobj(i)
				return true
			end
			if m.type == MT_PLAYER and m.player and m.player.valid then
				print(m.player.name.." was forcefully pushed by "..s.player.name..".")
			end
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & MF_ENEMY) then P_RemoveMobj(m) end
		end
		WARE_ForEachPlayer(function(p)
			--p.rings = 0 --p.mo.flags = $ & ~(MF_SHOOTABLE)
		end)
	end
})

WARE_AddMinigame("collect", {
	prompt = "Collect 3 rings!",
	
	music = "WAMCOL",
	skin = "metalsonic",
	
	spawnpoint = MAPPOS_AuxArena,
	positioning = {"scatter",MAPPOS_AuxArenaC1,MAPPOS_AuxArenaC2},
	nodeath = true,
	
	timelimit = 11*TICRATE,
	
	fStart = function()
		WARE.mem.nextspawn = 1
	end,
	fThink = function()
		if WARE.scaledtime > WARE.mem.nextspawn then
			// 0, 3, 6, 9
			--local h = WARE.playercount --max(WARE.playercount-1, 1)
			local h = max(WARE.playercount-1, 1)
			if WARE.mem.nextspawn==TICRATE then h = $+1 end // Be cool for the first batch only
			WARE.mem.nextspawn = $+3*TICRATE
			local c1 = MAPPOS_AuxArenaC1
			local c2 = MAPPOS_AuxArenaC2
			for i = 1,h do
				local ring = P_SpawnMobj(
					P_RandomRange(c1.x, c2.x)*FRACUNIT,
					P_RandomRange(c1.y, c2.y)*FRACUNIT,
					64*FRACUNIT,
					MT_FLINGRING
				)
				launchAbsolute(ring, P_RandomRange(0,359)*ANG1, ANG15, P_RandomRange(1,10)*FRACUNIT)
				--ring.fuse = 6*TICRATE
			end
		end
		WARE_ForEachPlayer(function(p)
			p.weapondelay = 2
			if p.rings >= 3 then
				WARE_PlayerWin(p,true)
			end
		end)
	end,
	fHud = function()
		hud.enable("rings")
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_FLINGRING then P_RemoveMobj(m) end
		end
		WARE_ForEachPlayer(function(p)
			p.rings = 0
		end)
	end
})

local modplat = deepcopy(MAPPOS_Platform)
modplat.z = 512
WARE_AddMinigame("push", {
	prompt = {"Hammer your opponents!","Stand your ground!"},
	
	condition = function() return WARE.playercount > 1 end,
	
	music = "WAMPSH",
	skin = "amy",
	
	spawnpoint = modplat,
	positioning = {"radial",128*FRACUNIT},
	--nodeath = true,
	
	timelimit = 14*TICRATE,
	
	fStart = function()
		--WARE.mem.nextspawn = TICRATE
		WARE_ForEachPlayer(function(p)
			p.mo.angle = R_PointToAngle2(p.mo.x, p.mo.y, modplat.x*FRACUNIT, modplat.y*FRACUNIT)
		end)
	end,
	fThink = function()
		WARE_ForEachPlayer(function(p)
			local ss = #p.mo.subsector.sector
			p.powers[pw_flashing] = 0
			WARE_PlayerSetStatus(p, (ss == 34 or ss == 35), false)
			if WARE.livingcount <= 1 and p.waremem.won then
				// Win only if still on ground
				WARE_PlayerSetStatus(p, true, true)
			end
		end)
	end,
	hMobjCollide = function(m,n) if collZCheck(m,n) then
		if m.type == n.type then
			if m.state == S_PLAY_MELEE_FINISH or m.state == S_PLAY_TWINSPIN then
				local rx,ry,rz = cSpdEx(m.angle, ANG15, 35*FRACUNIT)
				n.momx = rx
				n.momy = ry
				n.momz = rz
			end
		end
		return false
	end end,
	fEnd = function()
		
	end
})

local crushss = 56
local crushStart = 3*TICRATE
--local crushWhen = 6*TICRATE
WARE_AddMinigame("crusher", {
	prompt = "Don't get crushed!",
	
	music = "WAMCRH",
	skin = "sonic",
	
	spawnpoint = MAPPOS_Crusher,
	--positioning = {"radial",128*FRACUNIT},
	--nodeath = true,
	
	timelimit = 6*TICRATE,
	
	fStart = function()
		--WARE.mem.nextspawn = TICRATE
		local mem = WARE.mem
		local sprop = {}
		local faults = P_RandomRange(2,3)
		local mmm = {}
		for i = 1,12 do
			sprop[i] = {
				s=sectors[crushss+i-1],
				z=randomChoose({-64*FRACUNIT,64*FRACUNIT,0,0}),
				fault=0
			}
			mmm[i] = i
		end
		shuffleTable(mmm)
		for i = 1,faults do
			sprop[mmm[i]].fault = 64*FRACUNIT
		end
		mem.sprop = sprop
		WARE_ForEachPlayer(function(p)
			p.mo.flags2 = $|MF2_TWOD
		end)
		mem.crushed = false
		mem.crushing = false
		mem.rise = 256*FRACUNIT
		mem.mom = 0
		mem.ding = crushStart-3*TICRATE
	end,
	fThink = function()
		local mem = WARE.mem
		--local ctgt = 640*FRACUNIT
		--local ctgt = max(640-(WARE.scaledtime*2),128)*FRACUNIT
		/*if ctgt == 128*FRACUNIT and mem.crushed == false then
			S_StartSound(nil,sfx_pstop)
			mem.crushed = true
			P_StartQuake(FRACUNIT*8,TICRATE/4)
		else
			if WARE.time < 10 then
				S_StartSound(nil,sfx_eleva1)
			end
		end*/
		WARE_ForEachPlayer(WARE_PlayerWin)
		if WARE.scaledtime > mem.ding and mem.ding < crushStart then
			S_StartSound(nil,sfx_emfind)
			mem.ding=$+TICRATE
		end
		local g = FixedMul(FRACUNIT, WARE.spdcoef)
		if WARE.scaledtime > crushStart then
			if not mem.crushing then
				mem.crushing = true
				S_StartSound(nil,sfx_alarm)
				mem.mom = -FRACUNIT*8
			end
			mem.rise = $-mem.mom
			mem.mom = $+g
		end
		local ctgt = 128*FRACUNIT+max(0,mem.rise)
		if ctgt == 128*FRACUNIT and mem.crushed == false then
			S_StartSound(nil,sfx_pstop)
			mem.crushed = true
			P_StartQuake(FRACUNIT*8,TICRATE/4)
		end
		for i = 1,12 do
			local sprop = WARE.mem.sprop[i]
			local s = sprop.s
			s.floorheight = 128*FRACUNIT+sprop.z
			s.ceilingheight = ctgt+sprop.z+sprop.fault
		end
	end,
	fEnd = function()
		for ss = crushss,crushss+11 do
			local s = sectors[ss]
			s.floorheight = 0
			s.ceilingheight = 768*FRACUNIT
		end
		WARE_ForEachPlayer(function(p)
			p.mo.flags2 = $ & ~MF2_TWOD
		end)
	end
})

WARE_AddMinigame("shark", {
	/*
		One player takes the role of shark (Gray MetalSonic)
		The rest as blue abilityless sonic, slowed down
		Sonics have to reach land to win
		Shark has to tag a number of sonics
		tagged sonics die immediately
	*/
	prompt = "multiprompt...",
	
	condition = function() return WARE.playercount > 1 end,
	spawnpoint = MAPPOS_BeachUnderwater,
	positioning = {"scatter",MAPPOS_BeachUnderwaterC1,MAPPOS_BeachUnderwaterC2},
	
	music = "WAMSHK",
	
	timelimit = 15*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		// The Shark has to capture at least one player
		// Say, at least 1/3 of them?
		mem.target = (c+2)/3
		local plys = shuffleTable(WARE_GetPlaying())
		plys[1].waremem.shark = true
		WARE_ForEachPlayer(function(p)
			--p.waremem.TEST = true
			if not p.waremem.shark then	
				p.waremem.prompt = {"Get on the beach!","Avoid the Metal Shark!"}
				R_SetPlayerSkin(p, "sonic")
				WARE_ForcePlayerSkin(p, "sonic", SKINCOLOR_BLUE)
				p.charability = CA_NONE
				p.charability2 = CA2_NONE
				p.mo.angle = 0
			else
				--CONS_Printf(p,"You're the shark!")
				p.waremem.prompt = "Tag "..mem.target.." Sonics!"
				R_SetPlayerSkin(p, "metalsonic")
				WARE_ForcePlayerSkin(p, "metalsonic", SKINCOLOR_BLACK)
				--p.charability = CA2_NONE
				// 4540,-4480
				p.mo.angle = ANGLE_180
				P_TeleportMove(p.mo, 4540*FRACUNIT,-4480*FRACUNIT,500*FRACUNIT)
			end
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		local cankill = false
		WARE_ForEachPlayer(function(p)
			if not p.waremem.shark and not p.waremem.won and not p.waremem.wonlock then
				cankill = true
			end
		end)
		WARE_ForEachPlayer(function(p)
			p.powers[pw_underwater] = underwatertics
			if p.waremem.shark then
				if not (p.mo.eflags & MFE_UNDERWATER) then
					p.normalspeed = $/4
				end
				p.mo.scale = FRACUNIT*2
				if p.mo.x+p.mo.momx > 6200*FRACUNIT then
					p.mo.momx = -10*FRACUNIT
					P_TeleportMove(p.mo,6200*FRACUNIT,p.mo.y,p.mo.z)
				end
				if mem.target <= 0 then WARE_PlayerWin(p, true)
				else
					if not cankill then WARE_PlayerLose(p, true) end
				end
			else
				p.normalspeed = FixedMul($,FRACUNIT*3/4)
				if p.mo.x > 6200*FRACUNIT then WARE_PlayerWin(p, true) end
			end
		end)
	end,
	hMobjMoveCollide = function(m,n) if collZCheck(m,n) then
		if m.type == n.type and m.type == MT_PLAYER then
			if m.skin == "metalsonic" and n.skin == "sonic" and not n.player.waremem.wonlock then
				// Tagged!
				P_DamageMobj(n, m, m, 666)
				WARE_PlayerLose(n.player, true)
				WARE.mem.target = $-1
			end
		end
	end end,
	hHurtMsg = function(p,inf,src)
		if src and src.player and src.skin == "metalsonic" then
			print(p.name.." was bitten by "..src.player.name..".")
			return true
		end
	end,
})

WARE_AddMinigame("hunted", {
	/*
		One player takes the role of slowed abilityless knuckles,
		The rest as normal tails players
		played on a long slope
		tails starts at the base, while knuckles somewhere in the middle
		
		knuckles must reach the summit to win ("escaping")
		all tails players die if knuckles escapes
		individual tails players win (then die) if they have grabbed knuckles once
		knuckles wins if he escapes (all tails players die afterwards)
		
		knuckles will die after being grabbed several times
		
		prompts:
		knux: "Reach the summit!"
		tail: "Grab Knuckles before he escapes!"
	*/
	prompt = "multiprompt...",
	
	--incomplete = true, // I can't figure out how to banace this minigame yet
	condition = function() return WARE.playercount > 1 end,
	spawnpoint = MAPPOS_BigSlopeBase,
	
	music = "WAMRUN",
	
	timelimit = 18*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		// Knuckles can only be grabbed so many times
		--mem.lives = (c+2)/3
		mem.lives = (c+2)/3
		mem.escaped = false
		local plys = shuffleTable(WARE_GetPlaying())
		plys[1].waremem.knux = true
		WARE_ForEachPlayer(function(p)
			--p.waremem.TEST = true
			if p.waremem.knux then
				p.waremem.prompt = {"Reach the summit!","Don't let Tails grab you!"}
				R_SetPlayerSkin(p, "knuckles")
				WARE_ForcePlayerSkin(p, "knuckles", SKINCOLOR_RED)
				p.charability = CA_NONE
				p.charability2 = CA2_NONE
				local k = MAPPOS_BigSlopeMid
				--P_TeleportMove(p.mo, 4000*FRACUNIT,k.y*FRACUNIT,k.z*FRACUNIT)
				P_TeleportMove(p.mo, 4450*FRACUNIT,k.y*FRACUNIT,k.z*FRACUNIT)
			else
				p.waremem.prompt = "Grab Knuckles before he escapes!"
				R_SetPlayerSkin(p, "tails")
				WARE_ForcePlayerSkin(p, "tails", SKINCOLOR_ORANGE)
			end
			p.mo.angle = 0
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			local mem = WARE.mem
			local m = p.mo
			if p.waremem.knux then
				--p.normalspeed = FixedMul($,FRACUNIT*3/4)
				--p.normalspeed = FixedMul($,FRACUNIT*2/5)
				p.mo.scale = FRACUNIT*3
				--p.normalspeed = FixedMul($,FRACUNIT*2/5)/3 // wtf is scale omg
				p.normalspeed = FixedMul($,FRACUNIT/3)/3
				p.jumpfactor = 0
				if #m.subsector.sector == 53 then // At summit, stupid
					mem.escaped = true
					WARE_PlayerWin(p, true)
				end
				if not p.waremem.wonlock then
					if p.powers[pw_carry] == CR_PLAYER then
						local whomst = m.tracer.player -- i'm already tracer
						// Carrier immediately wins, knux loses a life
						WARE_PlayerWin(whomst, true)
						print(whomst.name.." grabbed "..p.name.."!")
						P_DamageMobj(whomst.mo,nil,nil,666,DMG_INSTAKILL)
						mem.lives = $-1
						p.powers[pw_carry] = 0
						p.mo.tracer = nil
					end
					if mem.lives <= 0 then
						--WARE_PlayerLose(p, true) -- instakill makes em lose anyways
						P_DamageMobj(m,nil,nil,666,DMG_INSTAKILL)
						print(p.name.."'s arms gave up.")
					end
				end
			else
				p.normalspeed = FixedMul($,FRACUNIT*3/4)
				if not p.waremem.wonlock then
					if mem.lives <= 0 or mem.escaped then
						// Knuckles died!!! or escaped!!! i don't care
						P_DamageMobj(m,nil,nil,666,DMG_INSTAKILL)
						--print(p.name.." escaped!")
					end
				end
			end
		end)
	end,
	fCollide = function(m,n) if m.skin == n.skin then return false end end,
	fHud = function(v,p,c)
		if p.waremem.knux and p.playerstate == PST_LIVE then
			drawStringMkII(v,160*FRACUNIT,35*FRACUNIT,WARE.mem.lives.." lives left",FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_RED,style=FS_FIXED})
		end
		
		local obituary
		if WARE.mem.escaped then
			obituary = "Knuckles escaped!"
		elseif WARE.mem.lives == 0 then
			obituary = "Knuckles' arms gave up!"
		end
		if obituary ~= nil then
			drawStringMkII(v,160*FRACUNIT,42*FRACUNIT,obituary,FONT_CONSOLE2,V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED})
		end
	end,
	hHurtMsg = function() return true end, // None of that
	fEnd = function()
		WARE_ForEachPlayer(function(p)
		
		end)
	end
})

WARE_AddMinigame("kamikaze", {
	prompt = "multiprompt",
	
	condition = function() return WARE.playercount > 1 end,
	skin = "knuckles",
	
	music = "WAMKMK",
	
	timelimit = 5*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		mem.howmany = min(2, (c+2)/3) // cap at 2
		mem.explode = false
		mem.exploded = false
		local plys = shuffleTable(WARE_GetPlaying())
		mem.bomber = plys[1]
		WARE_ForEachPlayer(function(p)
			if p == mem.bomber then
				local plu = mem.howmany == 1 and "" or "s"
				p.waremem.prompt = "Explode "..mem.howmany.." player"..plu.."!"
				p.powers[pw_shield] = SH_ARMAGEDDON
				P_SpawnShieldOrb(p)
				// &
			else
				p.waremem.prompt = "Avoid the kamikaze!"
			end
		end)
		mem.ding = 0
		mem.cool = P_SpawnMobj(0,0,0,MT_DUMMY)
	end,
	hShieldSpecial = function() return true end, // fok yuo
	fThink = function()
		local mem = WARE.mem
		local c = mem.cool
		if WARE.scaledtime >= 3*TICRATE+TICRATE/2 then mem.explode = true end
		if WARE_PlayerCompeting(mem.bomber) then
			local ec = mem.bomber.mo
			if WARE.scaledtime > mem.ding then
				mem.ding = $+TICRATE
				S_StartSound(ec,sfx_gbeep)
			end
			if c and c.valid then
				c.sprite = SPR_BMNE
				c.angle = ec.angle
				c.scale = FRACUNIT
				ec.flags2 = $|MF2_DONTDRAW
				P_TeleportMove(c, ec.x, ec.y, ec.z)
			end
		else
			if c and c.valid then P_RemoveMobj(c) end
		end
		WARE_ForEachPlayer(function(p)
			if p ~= mem.bomber then WARE_PlayerWin(p) end
		end)
		if mem.explode and not mem.exploded and WARE_PlayerInPlay(mem.bomber) then
			mem.exploded = true
			local ec = mem.bomber.mo
			local gotem = 0
			WARE_ForEachPlayer(function(p)
				local mem = WARE.mem
				local m = p.mo
				P_FlashPal(p, PAL_NUKE, 10)
				if p ~= mem.bomber then
					local dist = R_PointToDist2(R_PointToDist2(m.x, m.y, ec.x, ec.y),m.z,0,ec.z)
					if dist <= 512*FRACUNIT then
						P_DamageMobj(m,ec,ec,666,DMG_NUKE|DMG_INSTAKILL)
						gotem = $+1
					end
				else
					// The bomber!
					S_StartSound(ec, sfx_bkpoof)
					p.powers[pw_shield] = 0
				end
			end)
			WARE_PlayerSetStatus(mem.bomber, (gotem >= mem.howmany), true)
			P_DamageMobj(ec,nil,nil,666,DMG_NUKE|DMG_INSTAKILL)
		end
	end,
	hHurtMsg = function(p,inf,src)
		if p == WARE.mem.bomber then
			print(p.name.." left with a boom.")
			return true
		end
		if src and src.player == WARE.mem.bomber then
			print(p.name.." was exploded by "..src.player.name..".")
			return true
		end
	end,
})

WARE_AddMinigame("doors", {
	prompt = "Enter a door!",
	
	music = "WAMDOR",
	
	timelimit = 10*TICRATE,
	restoreonend = true,
	
	fStart = function()
		WARE_ForEachPlayer(function(p)
			if p.mo.x > 832*FRACUNIT then
				p.mo.momx = -30*FRACUNIT
				p.mo.momz = 10*FRACUNIT
			end
		end)
		local cols = {SKINCOLOR_RED,SKINCOLOR_GREEN,SKINCOLOR_BLUE}
		local align = {true, true, false}
		if P_RandomRange(1,max(1,8-WARE.speed)) == 1 then align[2] = false end
		shuffleTable(align)
		for i = -1,1 do
			local n = i+2
			local d = P_SpawnMobj(896*FRACUNIT, 512*i*FRACUNIT, 64*FRACUNIT, MT_DUMMY)
			d.radius = 16*FRACUNIT
			d.height = 32*FRACUNIT
			d.flags = 0
			d.scale = FRACUNIT*4
			d.sprite = SPR_RCRY
			d.color = cols[n]
			d.colorized = true
			--d.good = true
			d.good = align[n]
			--d.color = d.good and SKINCOLOR_GREEN or SKINCOLOR_RED
		end
	end,
	fThink = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			if p.mo.z < -3000*FRACUNIT and p.playerstate == PST_LIVE then
				S_StartSound(p.mo, sfx_q3fall)
				local st = p.mo.momz
				P_DamageMobj(p.mo, nil, nil, 999, DMG_DEATHPIT)
				p.mo.momz = st
			end
		end)
	end,
	hMobjMoveCollide = function(m,n) if collZCheck(m,n) then
		--print("deliciouse")
		if WARE.scaledtime < TICRATE then return end
		if m.type == MT_DUMMY and n.type == MT_PLAYER then
			local win = m.good == true
			local tg = win and MAPPOS_Beach or MAPPOS_Doors_Pit
			P_TeleportMove(n, tg.x*FRACUNIT, tg.y*FRACUNIT, tg.z*FRACUNIT+16*FRACUNIT)
			if win then
				WARE_PlayerWin(n.player, true)
			else
				n.momz = $ - FixedMul(40*FRACUNIT, WARE.spdcoef)
			end
		end
	end end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("race", {
	prompt = "Get to the end!",
	
	skin = "sonic",
	
	music = "WAMRCE",
	
	timelimit = 4*TICRATE,
	spawnpoint = MAPPOS_Race_Start,
	
	fStart = function()
		local mem = WARE.mem
		local x1,x2 = 5888,6912
		--local y1,y2 = -1152,256
		local y1,y2 = -1024+128,1024
		for i = 1,6+(WARE.speed/2) do
			local x = P_RandomRange(x1,x2)*FRACUNIT
			local y = P_RandomRange(y1,y2)*FRACUNIT
			local s = P_SpawnMobj(x, y, 8*FRACUNIT, MT_SPIKEBALL)
			s.scale = FRACUNIT*3/2
			s.moving = false
			--if P_RandomRange(1,3) == 1 then
			if true then
				s.moving = true
				s.flags = $|MF_BOUNCE
				--s.spd = P_RandomRange(5,20)*FRACUNIT
				s.spd = P_RandomRange(20,30)*FRACUNIT
				s.dir = randomChoose{-1,1}
				s.color = SKINCOLOR_RED
				s.colorized = true
			end
		end
		WARE_ForEachPlayer(function(p)
			p.mo.angle = ANGLE_90
			p.charability = 0
		end)
	end,
	hMobjThinker = function(m)
		if m.type == MT_SPIKEBALL and m.moving then
			if not m.go then
				m.momx = m.spd*m.dir
				m.go = true
			end
			if m.go then
				local mom = abs(m.momx)
				if m.momx < 0 and mom ~= m.spd then
					m.momx = -m.spd
				elseif m.momx > 0 and mom ~= m.spd then
					m.momx = m.spd
				end
			end
		end
	end,
	fThink = function()
		WARE_ForEachPlayer(function(p)
			p.jumpfactor = 0
			if p.mo.subsector.sector.special == 80 then
				WARE_PlayerWin(p,true)
			end
		end)
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_SPIKEBALL then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("move", {
	prompt = "I wonder lol",
	
	skin = "sonic",
	
	music = "WAMZZZ",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		mem.move = P_RandomChance(FRACUNIT/2)
		WARE_ForEachPlayer(function(p)
			p.waremem.prompt = mem.move and "Don't stop moving!" or "Don't move!"
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			WARE_PlayerWin(p)
			if mem.move then
				p.normalspeed = FixedMul($, FRACUNIT*3/4) // Make it easier to not bump into walls
			end
			if WARE.scaledtime > 2*TICRATE then
				local anymove = p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
				local anything = anymove or (p.cmd.buttons & (BT_JUMP|BT_USE))>0
				if mem.move then
					if (not anymove and p.speed < FixedMul(FRACUNIT*5, WARE.spdcoef))
					or (    anymove and p.speed < FixedMul(FRACUNIT*1, WARE.spdcoef)) then
						P_DamageMobj(p.mo, nil, nil, 999, DMG_INSTAKILL)
					end
				else
					if anything then
						P_DamageMobj(p.mo, nil, nil, 999, DMG_INSTAKILL)
					end
				end
			end
		end)
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_SPIKEBALL then P_RemoveMobj(m) end
		end
	end
})

// MT_THROWNGRENADE
WARE_AddMinigame("bomb", {
	prompt = "Watch out!",
	
	skin = "sonic",
	
	music = "WAMBOM",
	
	timelimit = 5*TICRATE,
	
	fStart = function()
		for i = 1,6 do
			local xr = P_RandomRange(-1024,1024)*FRACUNIT
			local yr = P_RandomRange(-1024,1024)*FRACUNIT
			local b = P_SpawnMobj(xr, yr, (1024-64)*FRACUNIT, MT_THROWNGRENADE)
			b.scale = FRACUNIT*3
			b.momz = FixedMul(-FRACUNIT*12, WARE.spdcoef)
			b.flags = ($|MF_NOGRAVITY) & ~(MF_GRENADEBOUNCE)
		end
	end,
	hMobjThinker = function(m)
		if m.type == MT_NIGHTSPARKLE then
			if not m.init then m.init = true;if P_RandomRange(1,4) ~= 1 then P_RemoveMobj(m) end end
		end
	end,
	fThink = function()
		WARE_ForEachPlayer(function(p) WARE_PlayerWin(p) end)
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & (MF_PAIN|MF_MISSILE))>0 then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("rollout", {
	// minigame_49 is for downwards
	prompt = "Climb up!",
	
	skin = "amy",
	spawnpoint = MAPPOS_BigSlopeBase,
	
	music = "WAMROK",
	
	timelimit = 26*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			p.mo.angle = 0
		end)
		mem.last = 0
	end,
	fThink = function()
		local mem = WARE.mem
		local top = MAPPOS_BigSlopeSummit
		while WARE.scaledtime > mem.last do
			//mem.last = $+17
			mem.last = $+P_RandomRange(5,15)
			for i = 1,1 do
				local len = 2176-64
				local ry = P_RandomRange(0,len)-(len/2)
				local r = P_SpawnMobj((top.x-384)*FRACUNIT,(top.y+ry)*FRACUNIT,(top.z+128)*FRACUNIT, MT_DUMMY)
				r.radius = mobjinfo[MT_ROLLOUTROCK].radius
				r.height = mobjinfo[MT_ROLLOUTROCK].height
				r.sprite = SPR_PUMI
				r.angle = FixedAngle(P_RandomRange(91,269)*FRACUNIT)
				r.momx,r.momy = cSpd(r.angle, 30*FRACUNIT)
				r.flags = ($|MF_BOUNCE) & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY)
			end
		end
		WARE_ForEachPlayer(function(p)
			p.normalspeed = $/3
			local m = p.mo
			if #m.subsector.sector == 53 then WARE_PlayerWin(p,true) end
			if m.state ~= S_PLAY_PAIN then m.player.powers[pw_flashing] = 0 end
		end)
	end,
	hMobjThinker = function(m)
		if m.type == MT_DUMMY then
			m.friction = FRACUNIT
			if m.standingslope then
				P_Thrust(m, m.standingslope.xydirection, m.standingslope.zdelta)
			end
			if m.x < 2240*FRACUNIT then P_RemoveMobj(m) end
		end
	end,
	hMobjMoveCollide = function(m,n) if collZCheck(m,n) then
		if m.type == MT_DUMMY and n.type == MT_PLAYER and n.player and n.state ~= S_PLAY_PAIN then
			S_StartSound(m, sfx_rokhit)
			P_DoPlayerPain(n.player, m, m)
			n.momx,n.momy,n.momz,m.momx,m.momy,m.momz = $4,$5,$6,$1,$2,$3
			n.momz = FRACUNIT*5
		end
	end end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("missile", {
	// The Missile Game 3D spiritual succesor:
	// Knockoff missile that dodges 128x128 squares
	prompt = "Dodge!",
	
	skin = "metalsonic",
	spawnpoint = MAPPOS_Missile_Ply,
	
	music = "WAMMS1",
	musicloop = true,
	notemposhift = true,
	
	timelimit = 15*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			p.mo.angle = 0
			p.aiming = 0
		end)
		mem.last = 0
		mem.cix = 0
		if WARE.speed >= 3 then S_ChangeMusic("WAMMS2", true) end
	end,
	fThink = function()
		local mem = WARE.mem
		local boss = WARE.mem.boss
		if WARE.scaledtime > mem.last then
			mem.cix = vWrapSuper($+1,SKINCOLOR_CARBON,SKINCOLOR_BLACK)
			local inc = TICRATE
			if boss then inc = max(20, 25 - (WARE.scaledtime/(TICRATE*2))) end
			mem.last = $+inc
			local o = deepcopy(MAPPOS_Missile_WallCorner)
			
			local pos = {0,1,2,3,4,5,6,7,8}
			
			--local MIN = 1
			--local MAX = P_RandomRange(1,3)
			
			local MIN = boss and 6 or 3
			local MAX = boss and 8 or 6
			
			if WARE.speed >= 3 then MIN,MAX = $1+1,$2+0 end
			local MINMAX = P_RandomRange(MIN,MAX)
			MINMAX = max(1,min(8,$)) // capped at 1 to 8, just in case
			for i = 1,MINMAX do
				local us = table.remove(pos, P_RandomRange(1,#pos))
				local uy = o.y*FRACUNIT-(us%3)*256*FRACUNIT
				local uz = o.z*FRACUNIT-(us/3)*256*FRACUNIT
				
				for yy = -1,1,2 do
				for zz = 0,1 do
					--local w = P_SpawnMobj(o.x*FRACUNIT, o.y*FRACUNIT, 0, MT_DUMMY)
					local w = P_SpawnMobj(o.x*FRACUNIT, uy+yy*64*FRACUNIT, uz+zz*128*FRACUNIT, MT_DUMMY)
					w.sprite = SPR_MWAL
					w.frame = $|FF_PAPERSPRITE
					w.angle = ANGLE_90
					w.radius = 64*FRACUNIT
					w.height = 128*FRACUNIT
					w.flags = ($) & ~(MF_NOCLIP|MF_NOCLIPHEIGHT)
					w.color = mem.toggle and SKINCOLOR_BLACK or SKINCOLOR_SILVER
					w.color = mem.cix
					w.kind = "wall"
				end
				end
			end
		end
		
		//mem.spd = -(not boss and 80*FRACUNIT or 128*FRACUNIT)
		//if boss then mem.spd = $+((FRACUNIT/35)*WARE.scaledtime) end
		//mem.spd = -80*FRACUNIT-((FRACUNIT/(TICRATE*3))*WARE.scaledtime*WARE.speed*2)
		mem.spd = -80*FRACUNIT-(15*FRACUNIT*WARE.speed)
		mem.spd = max($, -144*FRACUNIT+1) // Bad collisions if past this (block radius + player radius)
		
		WARE_ForEachPlayer(function(p)
			WARE_PlayerWin(p)
			p.normalspeed = 0
			p.jumpfactor = 0
			local m = p.mo
			p.pflags = $|PF_FORCESTRAFE
			m.flags = $|MF_NOGRAVITY
			m.state = S_PLAY_RUN
			
			local momfrict = FRACUNIT*3/4
			
			local xsV = FixedMul(vWrapSuper(AngleFixed(m.angle) , -180*FRACUNIT, 180*FRACUNIT-1), FRACUNIT*3/2)
			local ysV = FixedMul(vWrapSuper(AngleFixed(p.aiming), -180*FRACUNIT, 180*FRACUNIT-1), FRACUNIT*3/2)
			local xsM = -p.cmd.sidemove*FRACUNIT/5
			local ysM = p.cmd.forwardmove*FRACUNIT/5
			if p.pflags & PF_ANALOGMODE > 0 then xsV,ysV = 0,0 end // No
			
			local xs,ys = vClose(xsV,12000) or xsM, vClose(ysV,12000) or ysM
			
			if p.waremem.lastinit == nil then
				p.waremem.lastinit = true
				p.waremem.lastingZ = 0
				p.waremem.lastingY = 0
			end
			
			if p.playerstate ~= PST_DEAD then
				p.waremem.lastingZ = $+ys
				p.waremem.lastingY = $+xs
				
				m.momz = p.waremem.lastingZ
				m.momy = p.waremem.lastingY
				
				p.waremem.lastingZ = FixedMul($, momfrict)
				p.waremem.lastingY = FixedMul($, momfrict)
				
				m.angle = 0
				p.aiming = 0
				
				m.momx = 0
				P_TeleportMove(m, MAPPOS_Missile_Ply.x*FRACUNIT,m.y,m.z)
				
				local cam = p.waremem.cam
				if not (cam and cam.valid) then
					cam = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_DUMMY)
					cam.kind = "cam"
					p.waremem.cam = cam
				end
				
				if cam and cam.valid then
					P_TeleportMove(cam, m.x+m.radius+8*FRACUNIT,m.y,m.z+m.height/2)
					p.awayviewmobj = cam
					p.awayviewtics = 2
				end
			end
		end)
	end,
	hMobjThinker = function(m)
		local boss = WARE.mem.boss
		if m.type == MT_DUMMY then
			m.friction = FRACUNIT
			if m.kind == "wall" then
				--m.sprite = SPR_MWAL
				
			end
			if m.kind ~= "cam" then
				m.momx = WARE.mem.spd
			end
			if m.x <= 1900*FRACUNIT then P_RemoveMobj(m) end
		end
	end,
	hMobjMoveCollide = function(m,n) if collZCheck(m,n) then
		if m.type == MT_DUMMY and m.kind == "wall" and n.type == MT_PLAYER then
			S_StartSound(n, _G["sfx_impct"..P_RandomRange(1,4)])
			P_DamageMobj(n, m, m, 666, DMG_INSTAKILL)
			n.momx = m.momx
		end
	end end,
	hHurtMsg = function(p, inf, src)
		if src and src.type == MT_DUMMY then
			print(p.name.." met a wall.")
			return true
		end
	end,
	fEnd = function()
		WARE_ForEachPlayer(function(p)
			p.mo.flags = $ & ~MF_NOGRAVITY
			p.pflags = $ & ~PF_FORCESTRAFE
			p.awayviewtics = 0
			p.awayviewmobj = nil
		end)
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})

// MAPPOS_AuxArena
local TM_RED = 1
local TM_BLUE = 1
WARE_AddMinigame("teamball", {
	// Put more cannonballs to the other side before timelimit hits
	
	prompt = {"The side with the most","cannonballs loses!","If tied, everyone loses!"},
	
	//condition = function() return WARE.playercount > 1 and WARE.playercount % 2 == 0 end,
	DOESNOTCOUNT = true,
	incomplete = true,
	condition = function() return false end, // Not yet
	spawnpoint = MAPPOS_AuxArena,
	
	music = "WAMVLY",
	skin = "sonic",
	
	timelimit = 20*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		
		// odd numbers are shite
		
		local plys = shuffleTable(WARE_GetPlaying())
		for i = 1,#plys do
			if i <= c/2 then
				plys[i].team = favor
			else
				plys[i].team = unfavor
			end
		end
		
		WARE_ForEachPlayer(function(p)
			p.waremem.prompt = "Avoid Amy!"
			R_SetPlayerSkin(p, "sonic")
			WARE_ForcePlayerSkin(p, "sonic", SKINCOLOR_BLUE)
			p.charability = CA2_NONE
			P_TeleportMove(p.mo, -960*FRACUNIT, -1600*FRACUNIT, 0)
			p.mo.angle = ANGLE_315
		end)
		local ac = (c+3)/4
		local plys = WARE_GetPlaying()
		for ix = 1,ac do
			local p = table.remove(plys,P_RandomRange(1,#plys))
			p.waremem.hunter = true
			p.waremem.prompt = "Tag all Sonics!"
			R_SetPlayerSkin(p, "amy")
			WARE_ForcePlayerSkin(p, "amy", SKINCOLOR_ROSY)
			P_TeleportMove(p.mo, 960*FRACUNIT, -3520*FRACUNIT, 0)
			p.mo.angle = ANGLE_135
		end
		
		// -960 -1600
		// 960 -3520
	end,
	fThink = function()
		local mem = WARE.mem
		local sonicAlive = false
		WARE_ForEachPlayer(function(p)
			WARE_PlayerSetStatus(p, (p.mo.skin == "sonic"), false)
			if p.mo.skin == "sonic" and p.playerstate == PST_LIVE then sonicAlive = true end
		end)
		
		if not sonicAlive then
			WARE_ForEachPlayer(function(p)
				if p.mo.skin == "amy" then WARE_PlayerSetStatus(p, true, true) end
			end)
		end
	end,
	hMobjMoveCollide = function(m,n) if collZCheck(m,n) then
		if m.type == n.type and m.type == MT_PLAYER then
			if m.skin == "amy" and n.skin == "sonic" then
				// Tagged!
				P_DamageMobj(n, m, m, 666)
				WARE_PlayerLose(n.player, true)
			end
		end
	end end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & (MF_ENEMY|MF_MISSILE)) > 0 then P_RemoveMobj(m) end
		end
		WARE_FixOrigin()
	end
})

WARE_AddMinigame("stoplight", {
	prompt = {"Sneak to the end!"},
	
	spawnpoint = MAPPOS_Race_Start,
	
	music = "WAMSTP",
	skin = "sonic",
	
	timelimit = 20*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		
		WARE_ForEachPlayer(function(p)
			p.mo.angle = ANGLE_90
		end)
		local k = MAPPOS_Race_End
		local s = P_SpawnMobj(k.x*FRACUNIT,k.y*FRACUNIT,k.z*FRACUNIT,MT_EGGSTATUE)
		s.flags = ($|MF_NOCLIP) & ~MF_PUSHABLE
		s.angle = ANGLE_270
		s.scale = FRACUNIT*2
		mem.statue = s
		mem.when = TICRATE*3
		mem.domove = true
		mem.sangle = 0
		mem.starget = 0
	end,
	fThink = function()
		local mem = WARE.mem
		local s = mem.statue
		s.colorized = true
		
		if WARE.scaledtime > mem.when then
			local bonus = 0
			if mem.domove then bonus = $ end --??
			mem.when = $+TICRATE+bonus+P_RandomRange(TICRATE/2,TICRATE*2)
			mem.domove = not $
		end
		
		if mem.domove then
			s.color = SKINCOLOR_GREEN
			mem.starget = 90
			if mem.when - WARE.scaledtime < TICRATE then
				s.color = SKINCOLOR_YELLOW
				mem.starget = 90+45
			end
		else
			s.color = SKINCOLOR_RED
			mem.starget = 270
			if mem.when - WARE.scaledtime < TICRATE then
				s.color = leveltime/2%2 and SKINCOLOR_SALMON or SKINCOLOR_RED
				mem.starget = 270+45
			end
		end
		
		if mem.sangle ~= mem.starget then
			mem.sangle = vWrapSuper($+45, 0, 359)
		end
		s.angle = FixedAngle(mem.sangle*FRACUNIT)
		
		WARE_ForEachPlayer(function(p)
			p.normalspeed = $/3
			p.charability = CA_NONE
			p.charability2 = CA2_NONE
			if not p.waremem.wonlock and not mem.domove then
				if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
				or (p.cmd.buttons & (BT_JUMP)) > 0
				or not P_IsObjectOnGround(p.mo) then
					//WARE_PlayerLose(p, true)
					P_DamageMobj(p.mo, s, s, 666, DMG_INSTAKILL)
				end
			end
			if p.mo.subsector.sector.special == 80 then
				WARE_PlayerWin(p, true)
			end
		end)
	end,
	hHurtMsg = function(p, inf, src)
		if src and src.type == MT_EGGSTATUE then
			local extra = (not P_IsObjectOnGround(p.mo)) and " disappointed " or " "
			print(p.name.." could not stand the statue's"..extra.."gaze.")
			return true
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_EGGSTATUE then P_RemoveMobj(m) end
		end
	end
})

rawset(_G, "MODULMINI1", true)