// Nobody can stop me

/* Fan blades in ERZ are cross shaped polyobjects
The unseen center is 4x4 fracs big
The blades are 86 (90?) long, 4 wide
The fan particles are put up in a pentagonal shape, stupid

The fan container outer octagon is 120 long on orthogonal edges and 79.2 otherwise

The fan floaty area is 200 tall from fan origin
I have no fucking idea how strong is it
*/

WARE_AddMinigame("fan", {
	prompt = "Float up!",
	
	music = "WAMERZ",
	skin = "sonic",
	
	spawnpoint = MAPPOS_ERZ_Start,
	--positioning = {"scatter",MAPPOS_AuxArenaC1,MAPPOS_AuxArenaC2},
	--nodeath = true,
	
	//timelimit = 12*TICRATE+18,
	timelimit = 8*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		mem.fans = {}
		local pos = MAPPOS_ERZ_Start
		local start = 576
		local sep = 384*FRACUNIT
		local nowy = 0
		for i = 1,6 do
			local myx = sep*(i-1)
			local myy = 128*FRACUNIT*(nowy)
			local myz = 128*FRACUNIT*(i)
			local h = P_SpawnMobj((pos.x+start)*FRACUNIT+myx, pos.y*FRACUNIT+myy,(pos.z-96)*FRACUNIT+myz, MT_DUMMY)
			h.kind = "origin"
			table.insert(mem.fans, h)
			
			h.epic = i == 6
			
			nowy = $+randomChoose{1,-1}
			//if abs(nowy) > 5 then nowy = -$ end // Steer away
			-- lmao it would never get there, but if it did it wouldn't have worked like i wanted
		end
		WARE_ForEachPlayer(function(p) p.mo.angle = 0 end)
	end,
	fThink = function()
		local mem = WARE.mem
		local fans = mem.fans
		
		local fantall = 200*FRACUNIT
		local fanpropel = FixedMul(2*FRACUNIT,WARE.spdcoef)
		local fanmax = FixedMul(6*FRACUNIT,WARE.spdcoef)
		
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			if not p.waremem.won then
				for i = 1,#fans do
					local fan = fans[i]
					local dist = R_PointToDist2(m.x, m.y, fan.x, fan.y)
					if dist < 128*FRACUNIT
					and m.z < fan.z+fantall
					and fan.z < m.z+m.height then
						// Within fan range
						m.momz = min($+fanpropel, fanmax)
						p.pflags = $ & ~(PF_JUMPED)
						if m.state ~= S_PLAY_FALL then m.state = S_PLAY_FALL end
						if fan.epic then WARE_PlayerWin(p, true) end
					end
				end
			else
				m.momz = min($+fanpropel, fanmax)
			end
		end)
	end,
	hMobjThinker = function(m)
		if m.type == MT_DUMMY then
		
		if m.kind == "origin" then
			if not m.init then
				m.init = true
				m.blades = {}
				m.outer = {}
				for i = 1,8 do
					m.outer[i] = P_SpawnMobj(m.x, m.y, m.z, MT_DUMMY)
					if i <= 4 then m.blades[i] = P_SpawnMobj(m.x, m.y, m.z, MT_DUMMY) end
				end
			end
			m.angle = $+ANG20
			if m.epic then
				m.colorized = true
				m.color = SKINCOLOR_GREEN
			end
			for i = 1,4 do
				local blade = m.blades[i]
				blade.color = m.color;blade.colorized = m.colorized
				// Constantly rotating, and fast
				blade.sprite = SPR_FBLD
				blade.frame = A|FF_PAPERSPRITE
				blade.angle = m.angle + ANGLE_90*(i-1)
				P_TeleportMove(blade, m.x, m.y, m.z)
			end
			for i = 1,8 do
				local shell = m.outer[i]
				shell.color = m.color;shell.colorized = m.colorized
				// Just there
				shell.sprite = SPR_FBLD
				shell.frame = B|FF_PAPERSPRITE
				shell.angle = ANGLE_45*(i-1)
				local rx,ry = cSpd(shell.angle+ANGLE_90, 110*FRACUNIT)
				P_TeleportMove(shell, m.x+rx, m.y+ry, m.z)
			end
			local rainbow = {SKINCOLOR_RED,SKINCOLOR_YELLOW,SKINCOLOR_GREEN,SKINCOLOR_BLUE}
			if leveltime % 12 == 0 then
				for i = 0,4 do
					local rx,ry = cSpd(FixedAngle((FRACUNIT*360/5)*i)+m.angle, 72*FRACUNIT)
					local r = P_SpawnMobj(m.x+rx, m.y+ry, m.z+16*FRACUNIT, MT_DUMMY)
					r.kind = "particle"
					r.fuse = TICRATE*2
					r.color = randomChoose(rainbow);r.colorized = m.colorized
				end
			end
		end
		if m.kind == "particle" then
			m.flags = $ & ~MF_NOCLIP
			m.sprite = SPR_PRTL
			m.radius = 4*FRACUNIT
			m.height = 8*FRACUNIT
			m.momz = max(3*FRACUNIT, $)
		end
		
		end
	end,
	fCollide = function(m,n)
		if m.type == MT_DUMMY and m.kind == "particle" and n.type == MT_PLAYER and collZCheck(m,n) then
			m.momx = $+n.momx/12
			m.momy = $+n.momy/12
			m.momz = $+n.momz/12
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
		WARE_ForEachPlayer(function(p)
			p.rings = 0
		end)
	end
})

WARE_AddMinigame("riders", {
	/* Sonic Riders start line minigame
	Cross the starting line to win
	
	Crossing it before "GO" zaps you
	Taking longer than the specified time makes you lose
	
	SPR_SHCK
	ELEC AT 5440 2304
	 PLY AT 4224 2304
	DIST 1280
	*/
	prompt = "Time it!",
	
	music = "WAMRDR",
	musicloop = true,
	skin = "metalsonic",
	
	spawnpoint = MAPPOS_Riders_Ply,
	--positioning = {"scatter",MAPPOS_AuxArenaC1,MAPPOS_AuxArenaC2},
	--nodeath = true,
	
	//timelimit = 12*TICRATE+18,
	timelimit = 12*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local elec = MAPPOS_Riders_Elec
		mem.when = 4*TICRATE+P_RandomRange(TICRATE,TICRATE*3)
		mem.grace = TICRATE
		local sep = 192*FRACUNIT
		for i = -3,3 do
			local e = P_SpawnMobj(elec.x*FRACUNIT, elec.y*FRACUNIT+sep*i, elec.z*FRACUNIT, MT_DUMMY)
			e.kind = "zap"
			
			local e = P_SpawnMobj(elec.x*FRACUNIT, elec.y*FRACUNIT+sep*i, elec.z*FRACUNIT, MT_DUMMY)
			e.kind = "ind"
			e.ox = e.x
			e.oz = e.z
		end
		WARE_ForEachPlayer(function(p)
			p.mo.angle = 0
			p.charability2 = CA2_NONE
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		local elec = MAPPOS_Riders_Elec
		
		mem.cancross = WARE.scaledtime > mem.when and WARE.scaledtime < mem.when+mem.grace
		mem.couldcross = WARE.scaledtime > mem.when
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			if not p.waremem.wonlock and m.x > elec.x*FRACUNIT then
				if mem.cancross then
					WARE_PlayerWin(p, true) // yay
				else
					local s = m.momx
					P_DoPlayerPain(p,nil,nil)
					m.momx = min(-abs(s), -14*FRACUNIT)
				end
			end
			if WARE.scaledtime > mem.when+mem.grace then WARE_PlayerLose(p, true) end // bruh
		end)
	end,
	fHud = function(v,p,c)
		local mem = WARE.mem
		if WARE.scaledtime < mem.when+mem.grace then
			local sek = mem.when - WARE.scaledtime
			local str = sek/TICRATE+1
			if mem.cancross then str = "GO!" end
			local bump = FRACUNIT*5/2
			local cool = mem.cancross and SKINCOLOR_EMERALD or SKINCOLOR_JET
			drawStringMkII(v,(160)*FRACUNIT,(50)*FRACUNIT,
			str,FONT_CONSOLE2,V_SNAPTOTOP,
			{valign="center",align="center",color=cool,style=FS_FIXED,scale=bump})
		end
	end,
	hMobjThinker = function(m)
		local mem = WARE.mem
		if m.type == MT_DUMMY then
			if not m.r then m.r = P_RandomRange(0,7) end
			m.angle = ANGLE_90
			m.scale = FRACUNIT*2
			m.sprite = SPR_SHCK
			m.frame = (((leveltime)+m.r) % 8)|FF_PAPERSPRITE
			local cc = WARE.mem.cancross
			m.flags2 = ($|MF2_DONTDRAW) & ~(not cc and MF2_DONTDRAW or 0)
			
			if m.kind == "ind" then
				if mem.couldcross then m.flags2 = $|MF2_DONTDRAW end // always
				m.color = SKINCOLOR_GREEN
				m.colorized = true
				local frac = (mem.when - WARE.scaledtime)*FRACUNIT*8
				P_TeleportMove(m, m.ox-frac, m.y, m.oz-32*FRACUNIT)
			end
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("ramp", {
	/* Hit a target :))
	*/
	prompt = "Roll into the target!",
	
	music = "WAMEXP",
	skin = "sonic",
	
	spawnpoint = MAPPOS_Ramp_Apex,
	skynum = 1050,
	
	timelimit = 11*TICRATE+4,
	
	fStart = function()
		local mem = WARE.mem
		local p1 = MAPPOS_Ramp_EmptyC1
		local p2 = MAPPOS_Ramp_EmptyC2
		local myx = P_RandomRange(p1.x, p2.x)*FRACUNIT
		local myy = P_RandomRange(p1.y, p2.y)*FRACUNIT
		local myz = P_RandomRange(512, 1536)*FRACUNIT --P_RandomRange(p1.z, p2.z)*FRACUNIT
		local h = P_SpawnMobj(myx, myy, myz, MT_DUMMY)
		h.kind = "origin"
		mem.bullseye = h
		mem.radius = 256*FRACUNIT
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			P_TeleportMove(m, m.x-128*FRACUNIT, m.y, m.z)
			m.angle = ANGLE_180
			p.waremem.crossed = false
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		local be = mem.bullseye
		
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			if not p.waremem.crossed and m.x+m.momx <= mem.bullseye.x then
				p.waremem.crossed = true
				WARE_PlayerSetStatus(p, R_PointToDist2(m.y, m.z, be.y, be.z) < mem.radius, true)
				if p.waremem.won then
					S_StartSound(be, sfx_belhit)
					m.momz = abs($)
					m.momx = -($/4)
				end
			end
		end)
	end,
	hMobjThinker = function(m)
		local mem = WARE.mem
		if m.type == MT_DUMMY and m.kind == "origin" then
			if m.opangle == nil then m.opangle = 0 end
			local rot = ANG1*5
			m.angle   = $+rot
			m.opangle = $-rot
			local sgs = 12
			local scale = FRACUNIT*3
			for i = 1,sgs+sgs/2
				local gaming = FixedAngle(360*FRACUNIT / sgs * i)
				local rad = mem.radius
				local col = SKINCOLOR_RED
				local ang = m.angle
				if i > sgs then
					gaming = $*2
					rad = $/2
					col = SKINCOLOR_WHITE
					ang = m.opangle
				end
				local ry,rz = cSpd(ang+gaming, rad)
				local t = P_SpawnMobj(m.x, m.y+ry, m.z+rz-16*FRACUNIT, MT_DUMMY)
				t.scale = scale
				t.sprite = SPR_THOK
				t.color = col
				t.fuse = 2
			end
			local t = P_SpawnMobj(m.x, m.y, m.z-16*FRACUNIT, MT_DUMMY)
			t.scale = scale
			t.sprite = SPR_THOK
			t.color = SKINCOLOR_RED
			t.fuse = 2
		end
	end,
	hHurtMsg = function() return true end, // No death messages
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("waterskip", {
	prompt = "Waterskip REPLACE times!",
	
	music = "WAMWTR",
	skin = "sonic",
	
	spawnpoint = MAPPOS_SqBeach,
	
	timelimit = 9*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		mem.mintimes = P_RandomRange(2,5)
		mem.maxtimes = mem.mintimes+P_RandomRange(1,2) // Just in case
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			local conj = mem.mintimes
			if mem.maxtimes ~= mem.mintimes then conj = mem.mintimes.." to "..mem.maxtimes end
			p.waremem.prompt = {"Waterskip "..conj.." times,","then land!"}
			m.angle = ANGLE_180
			p.waremem.skipcount = 0
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			local prevmomz = p.waremem.prevmomz
			
			if prevmomz ~= nil then
				if prevmomz < 0 and m.momz > 0 then
					--print("Waterskip? "..leveltime)
					p.waremem.skipcount = $+1
				end
			end
			local c,min,max = p.waremem.skipcount,mem.mintimes,mem.maxtimes
			WARE_PlayerSetStatus(p, c >= min and c <= max, false)
			if c > max then WARE_PlayerLose(p, true) end
			if m.z < 300*FRACUNIT and P_IsObjectOnGround(m) then
				WARE_PlayerSetStatus(p, c >= min and c <= max, true)
			end
			
			p.waremem.prevmomz = m.momz
		end)
	end,
	fHud = function(v,p,c)
		drawStringMkII(v,160*FRACUNIT,35*FRACUNIT,
			p.waremem.skipcount.." skip"..(p.waremem.skipcount == 1 and "" or "s"),FONT_CONSOLE2,
			V_SNAPTOTOP,
			{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED}
		)
	end,
})


local origlen = 2176*FRACUNIT
//local orighlen = 1088*FRACUNIT
local orighlen = origlen/2
local orighlen2 = origlen+128*FRACUNIT
WARE_AddMinigame("detrain", {
	prompt = "Avoid!",
	
	music = "WAMTRA",
	--skin = "metalsonic",
	
	timelimit = 5*TICRATE+6,
	
	// LEN: 1088
	fStart = function()
		local mem = WARE.mem
		local ls = {}
		for i = 1,P_RandomRange(3,5) do
			// vert then pos
			local l = {P_RandomChance(FRACUNIT/2), P_RandomRange(-1088, 1088)*FRACUNIT}
			l[3] = (l[1] and ANGLE_180 or ANGLE_270) + (P_RandomChance(FRACUNIT/2) and ANGLE_180 or 0)
			ls[#ls+1] = l
			
			l.show = 17*(i-1)
			l.blast = l.show+TICRATE
			l.done = l.blast+TICRATE*2
		end
		mem.lines = ls

		for i = 1,#ls do
			local l = ls[i]
		end
	end,
	fThink = function()
		local mem = WARE.mem
		
		local ls = mem.lines
		local st = WARE.scaledtime
		local many = 64
		local sect = origlen / (many/2)
		
		for i = 1,#ls do
			local l = ls[i]
			
			if st > l.show and not l.shown then
				S_StartSound(nil, sfx_deton)
				l.shown = true
				for j = -many/2,many/2 do
					local ux,uy = l[2],0
					uy = sect*j
					if l[1] then ux,uy = uy,ux end
					local t = P_SpawnMobj(ux, uy, 8, MT_DUMMY)
					t.angle = l[3]
					t.sprite = SPR_DETN
					t.frame = A|FF_TRANS50
					t.kind = "line"
					t.num = i
				end
			end
			if st > l.blast and st <= l.done then
				local ux,uy,uz = l[2],0,0
				local rdev = 80
				uy,uz = P_RandomRange(-rdev,rdev)*FRACUNIT,P_RandomRange(-rdev,rdev)*FRACUNIT
				if l[1] then ux,uy = uy,ux end
				
				local rx,ry = cSpd(l[3]+ANGLE_180, orighlen - 4*FRACUNIT)
				local d = P_SpawnMobj(ux+rx, uy+ry, 48*FRACUNIT+uz, MT_DUMMY)
				d.height = 32*FRACUNIT
				d.radius = 16*FRACUNIT
				d.scale = FRACUNIT*2
				d.angle = l[3]
				d.sprite = SPR_DETN
				d.frame = A
				d.momx,d.momy = cSpd(l[3], FRACUNIT*48+P_RandomRange(1,48)*FRACUNIT)
				d.kind = "deton"
			end
		end
		WARE_ForEachPlayer(function(p) WARE_PlayerWin(p) end)
	end,
	hMobjThinker = function(m)
		if m.type == MT_DUMMY then
		if m.kind == "deton" then
			// I'm sorry:
			WARE_ForEachPlayer(function(p)
				local pm = p.mo
				// function(mz, mh, nz, nh)
				if collRadiusCheck(pm, m) then -- Ignoring Z - Go fuck yourself
					P_DamageMobj(pm, m, m, 6969, DMG_INSTAKILL)
				end
			end)
			if P_RandomRange(1,20) == 1 then
				S_StartSound(m, sfx_deton)
			end
			if abs(m.x) > orighlen2 or abs(m.y) > orighlen2 then
				P_RemoveMobj(m)
				return
			end
		end
		if m.kind == "line" then
			if WARE.scaledtime > WARE.mem.lines[m.num].blast then
				P_RemoveMobj(m)
				return
			end
		end
		
		end
	end,
	hHurtMsg = function(p,i,s)
		if s and s.type == MT_DUMMY then
			local obit = " met a terrible fate."
			if p.mo.z > 80*FRACUNIT then obit = " tried to cheat death." end
			print(p.name..obit)
			return true
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY or (m.flags & MF_ENEMY) then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("grab", {
	/*
		kind of a weird minigame tbf
		Let Tails pick up a Knuckles for both players to win
		If player count is odd, there will be an extra knuckles
		
		prompts:
		knux: "Be grabbed!"
		tail: "Grab a Knuckles!"
	*/
	prompt = "multiprompt...",
	
	condition = function() return WARE.playercount > 1 end,
	
	music = "WAMGRB",
	
	timelimit = 5*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		local plys = shuffleTable(WARE_GetPlaying())
		local ix = 0
		for i = 1,#plys do
			local p = plys[i]
			if i > c/2 then
				p.waremem.prompt = "Let Tails pick you up!"
				WARE_ForcePlayerSkin(p, "knuckles", SKINCOLOR_RED)
			else
				p.waremem.prompt = "Grab a Knuckles!"
				WARE_ForcePlayerSkin(p, "tails", SKINCOLOR_ORANGE)
			end
		end
	end,
	fThink = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			// Only check Knuckles players because fuck society
			if m.skin == "knuckles" then
				if p.powers[pw_carry] == CR_PLAYER then
					local whomst = m.tracer.player -- i'm already tracer
					if m.tracer.skin == "tails" then
						WARE_PlayerWin(p, true) // Carried wins
						WARE_PlayerWin(whomst, true) // Carrier wins
					end
				end
			end
		end)
	end,
})

WARE_AddMinigame("skin", {
	prompt = "Change your skin!",
	
	music = "WAMSKN",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		COM_BufInsertText(server, "restrictskinchange no")
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			P_ResetPlayer(p)
			P_TeleportMove(m, m.x, m.y, m.floorz)
			m.momx,m.momy,m.momz = 0,0,0
			p.waremem.oldskin = m.skin
			COM_BufInsertText(p, "skin "..p.mo.skin) // Just in case
		end)
	end,
	fThink = function()
		WARE_ForEachPlayer(function(p)
			if p.mo.skin ~= p.waremem.oldskin then
				WARE_PlayerWin(p, true) // Wow that was quick
			end
		end)
	end,
})

WARE_AddMinigame("emerald", {
	// Use your radar to find an emerald - Spin near the spot to dig
	prompt = {"Find the emerald!","Spin to dig!"},
	skin = "knuckles",
	spawnpoint = MAPPOS_Shootout_Center,
	skynum = 13,
	
	music = "WAMEMY",
	//musicloop = true,
	
	//sfx_emfind
	
	timelimit = 10*TICRATE+20,
	
	fStart = function()
		local mem = WARE.mem
		local rx,ry = 0,0
		--rx.ry = cSpd(P_RandomRange(0,359)*ANG1, P_RandomRange(-900,900)*FRACUNIT)
		// This is not true random and randomness says it will get clustered around the center and that's idiotic
		
		local fuck = false
		local a = 1024
		while not fuck do
			rx = P_RandomRange(-a,a)*FRACUNIT
			ry = P_RandomRange(-a,a)*FRACUNIT
			if R_PointToDist2(0,0,rx,ry) < 1000*FRACUNIT then fuck = true end
			// yea that's about right
		end
		
		local sc = MAPPOS_Shootout_Center
		rx = $+sc.x*FRACUNIT
		ry = $+sc.y*FRACUNIT
		mem.where = {x=rx,y=ry}
		WARE_ForEachPlayer(function(p)
			p.waremem.nearlvl = 999
			p.waremem.ding = 0
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		local emmy = mem.where
		local sep = 90*FRACUNIT
		WARE_ForEachPlayer(function(p)
			local m = p.mo
			local dist = R_PointToDist2(m.x,m.y,emmy.x,emmy.y)
			local l = 0
			repeat l = $+1 until sep*l > dist
			p.waremem.nearlvl = l
			
			p.waremem.ding = $+1
			
			if not p.waremem.wonlock then
				if l < 6 and p.waremem.ding > l*4 then
					p.waremem.ding = 0
					S_StartSound(nil, sfx_emfind, p)
				end
				
				if l <= 1 and (p.pflags & PF_STARTDASH) then
					WARE_PlayerWin(p, true)
				end
			end
		end)
	end,
	fHud = function(v,p,c)
		local mem = WARE.mem
		local m = p.mo
		
		if WARE_PlayerInField(p) and not p.waremem.wonlock then
			local lvl = 7-min(max(1, p.waremem.nearlvl), 6)
			local str = "HOMING"..(lvl)
			v.draw(160-8, 150-16, v.cachePatch(str))
		end
	end,
})

// LEN: 1664
WARE_AddMinigame("glowball", {
	// soni 3 c
	prompt = "Exit!",
	skin = "sonic",
	spawnpoint = MAPPOS_Glowball,
	skynum = 1028,
	
	music = "WAMGBL",
	--musicloop = true,
	timelimit = 14*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local rx,ry = 0,0
		
		local gb = MAPPOS_Glowball
		mem.balls = {} //heh
		--for i = -1,1 do for j = 0,2 do
		local zs = (gb.z-8)*FRACUNIT
		for iz = 1,7 do
			--local rx,rz = i*300*FRACUNIT,j*300*FRACUNIT
			--local rx = P_RandomRange(-1024,1024)*FRACUNIT
			local rx = P_RandomRange(-768,768)*FRACUNIT
			if iz == 1 then rx = 0 end // Always spawn next to one
			local b = P_SpawnMobj(gb.x*FRACUNIT+rx, gb.y*FRACUNIT, zs, MT_DUMMY)
			b.kind = "glowball"
			b.radius = 40*FRACUNIT
			b.height = 80*FRACUNIT
			b.scale = FRACUNIT*2
			
			mem.balls[#mem.balls+1] = b
			--zs = $+P_RandomRange(300,600)*FRACUNIT
			zs = $+256*FRACUNIT
		end
		
		mem.exit = zs+128*FRACUNIT
		R_PointInSubsector(gb.x*FRACUNIT, gb.y*FRACUNIT).sector.ceilingheight = mem.exit+512*FRACUNIT
		
		local function checky(bp)
			for i = 1,#mem.balls do
				local b = mem.balls[i]
				if R_PointToDist2(b.x,b.z,bp.x,bp.z) <= bp.radius+b.radius+20*FRACUNIT then return false end
			end
			return true
		end
		local bmin = 15
		local bmax = bmin+P_RandomRange(0,10)
		for i = bmin,bmax do
			local bp = P_SpawnMobj(0,0,0,MT_BUMPER)
			repeat
				P_TeleportMove(bp, 
					gb.x*FRACUNIT+P_RandomRange(-1024,1024)*FRACUNIT,
					gb.y*FRACUNIT,
					P_RandomRange(128,zs/FRACUNIT)*FRACUNIT
				)
			until checky(bp)
		end
		
		WARE_ForEachPlayer(function(p)
			local wm = p.waremem
			wm.ball = nil // Tethered to
			wm.last = nil // Last ball we were in contact with
			wm.grace = 0 // If over 0, cannot recollide with last
			wm.angleroll = 0 // Aiming towards?
			wm.anglepitch = 0 // How much
			
			p.mo.flags2 = $|MF2_TWOD
		end)
	end,
	fThink = function()
		local mem = WARE.mem
		local gby = MAPPOS_Glowball.y*FRACUNIT
		
		//wm.visline = vWrapSuper($+seglen/8, 0, seglen)
		local gbx = MAPPOS_Glowball.x*FRACUNIT
		local rlen = 1664*FRACUNIT
		local segs = 32
		local seglen = rlen/segs
		for i = -segs/2,segs/2 do
			local offz = FixedAngle(WARE.scaledtime*16*FRACUNIT+i*64*FRACUNIT)
			local t = P_SpawnMobj(gbx+i*seglen, gby, mem.exit+sin(offz)*32, MT_THOK)
			t.fuse = 2
			t.color = P_RandomRange(0,#skincolors-1)
		end
		
		WARE_ForEachPlayer(function(p)
			p.accelstart = FixedMul($*FRACUNIT, FRACUNIT*4/3)/FRACUNIT
			p.acceleration = FixedMul($*FRACUNIT, FRACUNIT*4/3)/FRACUNIT
			local m = p.mo
			local wm = p.waremem
			
			if wm.grace > 0 then wm.grace = $-1 end
			
			if WARE_PlayerCompeting(p) then
				if m.state ~= S_PLAY_ROLL then m.state = S_PLAY_ROLL end
				
				if wm.ball then
					local b = wm.ball
					wm.vaim = 0
					wm.haim = 0
					if not S_SoundPlaying(b, sfx_s3kc6l) then
						S_StartSound(b, sfx_s3kc6l)
					end
					m.flags = $|MF_NOGRAVITY
					local orbspd = FixedAngle(FixedMul(FRACUNIT*9, WARE.spdcoef))
					wm.anglepitch = $-orbspd
					m.momx,m.momy,m.momz = 0,0,0
					
					local side = p.cmd.sidemove
					if abs(side) > 10 then
						local spd = ANG1*4
						if side < 0 then wm.angleroll = $+spd
						else wm.angleroll = $-spd end
					end
					local spd = b.radius
					local rx = FixedMul(FixedMul(spd, cos(wm.anglepitch)), cos(wm.angleroll))
					local ry = FixedMul(spd, sin(wm.anglepitch))
					local rz = FixedMul(FixedMul(spd, sin(wm.angleroll)), cos(wm.anglepitch))
					P_TeleportMove(m, b.x+rx, b.y+ry/3, b.z+rz+b.height/2-m.height/2)
					
					--print(AngleFixed(wm.anglepitch)/FRACUNIT,
					--AngleFixed(wm.angleroll)/FRACUNIT)
					
					if not wm.wasjumping and (p.cmd.buttons & BT_JUMP) then
						if S_SoundPlaying(b, sfx_s3kc6l) then
							S_StopSound(b)
						end
						local rad = wm.ball.radius
						wm.last = wm.ball
						wm.ball = nil
						wm.grace = 8
						
						// Realign
						P_TeleportMove(m, m.x, gby, m.z)
						
						// Catapult
						local dist = R_PointToDist2(b.x,b.z+b.height/2, m.x,m.z+m.height/2)
						--local ang = R_PointToAngle2(b.x,b.z+b.height/2, m.x,m.z+m.height/2)
						local ang = AngleFixed(wm.angleroll)
						local inv = AngleFixed(wm.anglepitch) < 180*FRACUNIT and 1 or -1
						//if AngleFixed(wm.anglepitch) < 180*FRACUNIT then ang = -ang end
						--m.momx,m.momy,m.momz = cSpdEx(0, ang, dist/2)
						m.momx,m.momy,m.momz = cSpdEx(0, FixedAngle(ang), inv*max(8*FRACUNIT, (rad-dist)/2))
						--m.momz = 10*FRACUNITdddddw
					end
				else
					for i = 1,#mem.balls do
						local b = mem.balls[i]
						if (b ~= wm.last or wm.grace == 0) // Same ball within grace time
						//and not collZCheck(m,b) // COLLIDING in the Z plane?
						and R_PointToDist2(b.x,b.z+b.height/2, m.x,m.z+m.height/2) <= b.radius then
							wm.ball = b // Bal tim
							wm.angleroll = R_PointToAngle2(b.x,b.z+b.height/2, m.x,m.z+m.height/2)
							wm.anglepitch = 0
						end
					end
				end
				
				if not wm.ball then
					if m.z > mem.exit then WARE_PlayerWin(p, true) end
					if m.z < 64*FRACUNIT then P_DamageMobj(m,nil,nil,666,DMG_PIT) end
					//m.momz = 20*FRACUNIT end
					if m.y ~= gby then
						P_TeleportMove(m, m.x, gby, m.z)
					end
					if not p.waremem.wonlock then
						m.flags = $ & ~MF_NOGRAVITY
					else
						if p.waremem.won then
							m.flags = $|MF_NOGRAVITY
							m.momz = 2*FRACUNIT
						end
					end
				end
				
				wm.wasjumping = (p.cmd.buttons & BT_JUMP) > 0
			end
		end)
	end,
	hMobjThinker = function(m)
		if m.type == MT_DUMMY then
			if m.kind == "glowball" then
				m.sprite = SPR_GBAL
				m.frame = leveltime%5
			end
		end
	end,
	fEnd = function()
		WARE_ForEachPlayer(function(p)
			p.mo.flags = $ & ~MF_NOGRAVITY
			p.mo.flags2 = $ & ~MF2_TWOD
		end)
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY or m.type == MT_BUMPER then P_RemoveMobj(m) end
		end
	end
})


// ColorOpposite(int color)
WARE_AddMinigame("origin", {
	prompt = "multiprompt",
	
	condition = function() return WARE.playercount > 1 end,
	skin = "knuckles",
	
	music = "WAMBST",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		local c = WARE.playercount
		mem.howmany = (c-1)/2
		local plys = shuffleTable(WARE_GetPlaying())
		mem.origin = plys[1]
		WARE_ForEachPlayer(function(p)
			if p == mem.origin then
				p.waremem.prompt = {"Have "..mem.howmany.." players","or less around you!"}
			else
				p.waremem.prompt = {"Stay near","the highlighted player!"}
			end
		end) // &
		mem.radius = 500*FRACUNIT
		mem.col = P_RandomRange(0,#skincolors-1)
	end,
	fThink = function()
		local mem = WARE.mem
		if mem.origin ~= nil then // Just in case
			local inrad = 0
			WARE_ForEachPlayer(function(p)
				if p == mem.origin then return end
				local b = mem.origin.mo
				local m = p.mo
				m.color = mem.col
				local close = R_PointToDist2(b.x,b.y,m.x,m.y) <= mem.radius
				if close then
					inrad = $+1
				end
				WARE_PlayerSetStatus(p, close, false)
			end)
			local p = mem.origin
			local m = p.mo
			m.color = ColorOpposite(mem.col)
			WARE_PlayerSetStatus(p, inrad <= mem.howmany, false)
			
			local ef = 12
			for i = 1,ef do
				local pc = FixedAngle(FRACUNIT*360/ef*i + WARE.scaledtime*3*FRACUNIT)
				local rx,ry = cSpd(pc, mem.radius)
				local t = P_SpawnMobj(m.x+rx, m.y+ry, m.z, MT_THOK)
				t.frame = A
				t.fuse = 2
				t.color = m.color
			end
		end
	end,
})

freeslot("S_WALTER")
states[S_WALTER] = {
	sprite = SPR_WLTR,
	frame = A,
	tics = -1,
	action = A_VileTarget,
	var1 = MT_CYBRAKDEMON_TARGET_RETICULE,
	var2 = 1,
	nextstate = S_WALTER
}
local platforms = {7,6,10,9,5,4,3,8,1} // 16, 32, 48 hardcoded af
WARE_AddMinigame("walter", {
	// Walter spawns somewhere in the map, players have to break line of sight.
	// At least 2 platforms rise to maximum height.
	// Players are teleported off if they are in a platform to be risen.
	// Walter will avoid spawning on a platform on sky level.
	prompt = "Hide!",
	
	music = "WAMWOW",
	skin = "sonic",
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		
		local ps = shuffleTable(deepcopy(platforms))
		local bad = {}
		
		local walters = P_RandomRange(1,2)
		local plats = walters
		for i = 1,#ps do sectors[ps[i]].floorheight = 0 end
		for i = 1,plats do
			bad[#bad+1] = ps[i]
			local s = sectors[ps[i]]
			s.floorheight = 128*FRACUNIT
		end
		
		/*WARE_ForEachPlayer(function(p)
			local m = p.mo
			while findValueInTable(bad, #m.subsector.sector) ~= nil do
				local xr,yr = cSpd(R_PointToAngle2(0,0,m.x,m.y), 10*FRACUNIT)
				P_TeleportMove(m, m.x+xr,m.y+yr,m.z)
			end
		end)*/
		// Not necessary since apparently walter can see you on a tall surface lol
		
		mem.monstertruck = {}
		
		for i = 1,walters do
			local w = P_SpawnMobj(0,0,128*FRACUNIT,MT_DUMMY)
			repeat 
				local xw = P_RandomRange(-1024,1024)*FRACUNIT
				local yw = P_RandomRange(-1024,1024)*FRACUNIT
				P_TeleportMove(w, w.x+xw,w.y+yw,w.z)
			until findValueInTable(bad, #w.subsector.sector) == nil
			w.height = 128*FRACUNIT
			w.sprite = SPR_WLTR
			w.scale = FRACUNIT
			w.flags = 0
			mem.monstertruck[#mem.monstertruck+1] = w
		end
		
	end,
	fThink = function()
		local mem = WARE.mem
		WARE_ForEachPlayer(function(p)
			local seen = true
			for i = 1,#mem.monstertruck do
				local w = mem.monstertruck[i]
				--w.state = S_WALTER
				--A_VileTarget(w, MT_CYBRAKDEMON_TARGET_RETICULE, 1)
				
				if P_CheckSight(w, p.mo) then
					seen = false
				end
			end
			WARE_PlayerSetStatus(p, seen, false)
		end)
	end,
	hMobjDamage = function(m,i,s)
		if (m.flags & MF_ENEMY) and s and s.valid and s.type == MT_PLAYER then
			WARE_PlayerWin(s.player, true)
		end
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if m.type == MT_DUMMY then P_RemoveMobj(m) end
		end
		WARE_FixOrigin()
	end
})

rawset(_G, "MODULMINI2", true)