rawset(_G, "WARE", {})
// All gametype bullshit
// Do not store static settings here! This is specific for dynamic things like timers and such

rawset(_G, "WAREPERM", {})
// Permanent settings that are not supposed to be accessed by minigames, but they can anyways lol

local sndfree = {
	{"sfx_wawin" , "You won!"},
	{"sfx_wawin2", "(Someone won)"},
	{"sfx_watik1", "Tick..."},
	{"sfx_watik2", "Tock..."},
	{"sfx_q3fall", "AAAAAAHHHHHHHhhhhh..."},
	{"sfx_alwigt", "\"That'll hold 'em alwight! Hehehehehehe\""},
	{"sfx_fooey" , "\"Fooey.\""},
	{"sfx_q3mnu4", "Monitor destroyed"},
	{"sfx_rokhit", "Hit a rock"},
	{"sfx_impct1", "Someone died"},
	{"sfx_impct2", "Someone died"},
	{"sfx_impct3", "Someone died"},
	{"sfx_impct4", "Someone died"},
	{"sfx_wgfire", "\"FIRE!\""},
	{"sfx_gunjam", "Gun jammed"},
	{"sfx_belhit", "Target hit"},
	{"sfx_hahaha", "Ha-ha-ha-ha"},
	{"sfx_ronalo", "SRB2 SOCKSER"},
}
for i = 1,#sndfree do
	local e = sndfree[i]
	freeslot(e[1])
	sfxinfo[_G[e[1]]].caption = e[2]
end

sfxinfo[sfx_belhit].flags = SF_X4AWAYSOUND

freeslot(
	"SPR_CHUN", -- chungus
	"SPR_MWAL", -- a wall
	"SPR_FBLD", 
	"SPR_SOCC", -- footbal
	"SPR_GBAL",
	"SPR_WLTR" -- walter
)


// The numbering is funny. It feels a bit like nerd/developer humor;
// massively underselling the thing as a way of being both sardonic
// and self-effacing but maybe I'm imagining it.
rawset(_G, "WAREERSION", "1.2") // lol
rawset(_G, "WAREVERSION", "v"..WAREERSION)

freeslot("TOL_WARE")
local template = setmetatable({
	name = "SRB2Ware "..WAREVERSION,
    identifier = "ware",
    typeoflevel = TOL_WARE,
    rules = GTR_RINGSLINGER|GTR_NOTITLECARD|GTR_SPECTATORS|GTR_RESPAWNDELAY|GTR_DEATHMATCHSTARTS,
    intermissiontype = int_match,
	rankingtype = GT_MATCH,
    --headercolor = 73,
	headerleftcolor = 73,
	headerrightcolor = 73,
    description = "Compete against other players in a series of microgames, and achieve the highest amount of points!"
},{
	__add = function(a,b)
		local r = {}
		for tk,tv in ipairs{a,b} do
		for k,v in pairs(tv) do
			r[k] = v
		end
		end
		return r
	end
})
G_AddGametype(
	template -- Original
)
G_AddGametype(template + {
    name = "CustomWare "..WAREVERSION,
    identifier = "warecustom",
	headerleftcolor = 64,
    description = "Want to have slightly more control over how Ware is played? Well, here you go!"
})
G_AddGametype(template + {
    name = "DebugWare "..WAREVERSION,
    identifier = "waredebug",
    headerleftcolor = 112,
    description = "Testing tool to make sure the game doesn't collapse or if you want to have ultimate control over the game. However, if something breaks, you will receive zero support."
})

freeslot("MT_DUMMY")
mobjinfo[MT_DUMMY] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1,
	radius = 4,
	height = 4,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

rawset(_G, "WARETAG", "\x8e".."[WARE]\128")