// 1.2 onwards

WARE_AddMinigame("loserings", {
	DOESNOTCOUNT = true,
	incomplete = true,
	prompt = "Lose your rings!",
	-- How do I make this engaging?
	-- It's literally killbot again!
	
	music = "WAMLSE",
	--skin = "sonic",
	
	--positioning = {"scatter",MAPPOS_AuxArenaC1,MAPPOS_AuxArenaC2},
	nodeath = true,
	
	timelimit = 4*TICRATE,
	
	fStart = function()
		local mem = WARE.mem
		for i = 1,3 do
			--local xr = P_RandomRange(-1280,1280)*FRACUNIT
			local xr = P_RandomRange(-1024,1024)*FRACUNIT
			local yr = P_RandomRange(-1024,1024)*FRACUNIT
			local b = P_SpawnMobj(xr,yr,4*FRACUNIT,MT_EGGMAN_BOX)
			--b.flags = ($|MF_SOLID|MF_PAIN) & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP)
			S_StartSound(b, sfx_appear)
		end
		WARE_ForEachPlayer(function(p)
			p.rings = 5
		end)
	end,
	fThink = function()
		WARE_ForEachPlayer(function(p)
			--if p.rings == 0 then WARE_PlayerWin(p, true) end
		end)
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & MF_MONITOR) then P_RemoveMobj(m) end
		end
	end
})

WARE_AddMinigame("limboish", {
	DOESNOTCOUNT = true,
	-- Unplayable - Not even done
	prompt = {"Spin under the bar!","No spindashing!"},
	
	music = "WAMLSE",
	--skin = "sonic",
	
	--positioning = {"scatter",MAPPOS_AuxArenaC1,MAPPOS_AuxArenaC2},
	nodeath = true,
	
	timelimit = 11*TICRATE+23, -- 11.786
	
	fStart = function()
		local mem = WARE.mem
		for i = 1,3 do
			--local xr = P_RandomRange(-1280,1280)*FRACUNIT
			local xr = P_RandomRange(-1024,1024)*FRACUNIT
			local yr = P_RandomRange(-1024,1024)*FRACUNIT
			local b = P_SpawnMobj(xr,yr,4*FRACUNIT,MT_EGGMAN_BOX)
			--b.flags = ($|MF_SOLID|MF_PAIN) & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP)
			S_StartSound(b, sfx_appear)
		end
		WARE_ForEachPlayer(function(p)
			p.rings = 5
		end)
	end,
	fThink = function()
		WARE_ForEachPlayer(function(p)
			--if p.rings == 0 then WARE_PlayerWin(p, true) end
		end)
	end,
	fEnd = function()
		for m in mobjs.iterate() do
			if (m.flags & MF_MONITOR) then P_RemoveMobj(m) end
		end
	end
})

rawset(_G, "MODULMINI3", true)